package org.systemsbiology.jrap.extension;

import java.io.FileInputStream;
import java.io.IOException;

import org.systemsbiology.jrap.MSXMLParser;
import org.systemsbiology.jrap.MZXMLFileInfo;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 * 
 * 
 * @author nikitin
 *
 */
public class ExtMSXMLParser extends MSXMLParser {

	public ExtMSXMLParser(String fileName) {
		super(fileName);
	}
	
	public ExtMSXMLParser(String fileName, ExtSAX2ScanHeaderHandler handler) {
		super(fileName);
		
	}
	
	public int getScanCount()
	{
		return super.getScanCount();
	}

	public MZXMLFileInfo getHeaderInfo()
	{
		return super.getHeaderInfo();
	}
	
	public ExtScanHeader rapHeader(int scanNumber)
	{
		FileInputStream fileIN = null;
		try
		{
			fileIN = new FileInputStream(fileName);
			fileIN.skip(indexHandler.getScanOffset(scanNumber));
		} catch (Exception e)
		{
			System.out.println("File exception:" + e);
			e.printStackTrace();
		}

		ExtSAX2ScanHeaderHandler scanHeaderHandler = new ExtSAX2ScanHeaderHandler();
		try
		{
			parser.setContentHandler(scanHeaderHandler);
			parser.setErrorHandler(scanHeaderHandler);
			parser.parse(new InputSource(fileIN));
		} catch (SAXParseException e)
		{
			// ignore
		} catch (Exception e)
		{
			if (!e.getMessage().equals("ScanHeaderEndFoundException"))
			{
				System.err.println("error: Parse error occurred - "
						+ e.getMessage());
				Exception se = e;
				if (e instanceof SAXException)
				{
					se = ((SAXException) e).getException();
				}
				if (se != null)
					se.printStackTrace(System.err);
				else
					e.printStackTrace(System.err);
			}
		}
		return scanHeaderHandler.getScanHeader();
	}
	
	public ExtScan rap(int scanNumber) {
		FileInputStream fileIN = null;

		try
		{
			fileIN = new FileInputStream(fileName);
			fileIN.skip(indexHandler.getScanOffset(scanNumber));
		} catch (Exception e)
		{
			System.out.println("File exception:" + e);
			e.printStackTrace();
		}

		ExtSAX2ScanHandler scanHandler = new ExtSAX2ScanHandler();
		
		try
		{
			parser.setContentHandler(scanHandler);
			parser.setErrorHandler(scanHandler);
			try {
				parser.parse(new InputSource(fileIN));
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} catch (SAXParseException e)
		{
			// ignore
		} catch (SAXException e)
		{	
			if (!e.getMessage().equals("ScanEndFoundException"))
			{
				System.err.println("error: Parse error occurred - "
						+ e.getMessage());
				Exception se = e;
				if (e instanceof SAXException)
				{
					se = ((SAXException) e).getException();
				}
				if (se != null)
					se.printStackTrace(System.err);
				else
					e.printStackTrace(System.err);
			}
		}
		return scanHandler.getScan();
	}
}
